// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services',
        'starter.directive', 'ngResource', 'ngCordova', 'ngMessages',
        'angular-carousel', 'ionic-native-transitions'
    ])
    .constant('API_URI', 'http://220.165.9.218:8091/index.php/Api/')
    // .constant('API_URI', 'http://swx.dev/Api/')
    .constant('STATIC_URI', 'http://220.165.9.218:8082/')
    .run(function ($ionicPlatform, $cordovaDevice, $cordovaToast, $cordovaStatusbar,
        $ionicModal, $rootScope, $state, locals, $timeout, $ionicSlideBoxDelegate,
        Search, Cart, GoodsDetail, $ionicNativeTransitions, Collect) {
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(false);

            }
            if (cordova.platformId == 'android') {
                // org.apache.cordova.statusbar required
                // StatusBar.styleDefault();
                StatusBar.overlaysWebView(true);
                StatusBar.styleLightContent();
                StatusBar.backgroundColorByHexString("#33cd5f");
                $rootScope.detail_menu_bottom = 0;
            } else {
                $ionicNativeTransitions.enable(false);
                $rootScope.detail_menu_bottom = '18px';
            }

            // 状态栏
            $cordovaStatusbar.overlaysWebView(true);
            $cordovaStatusbar.style(1);
            $cordovaStatusbar.styleHex('#33cd5f');


            document.addEventListener("deviceready", function () {
                // 获取设备信息
                var device = $cordovaDevice.getDevice();
                locals.setObject('device', device);
                // 网络离线时
                $rootScope.$on('$cordovaNetwork:offline', function (event, networkState) {
                    // var offlineState = networkState;
                    $cordovaToast.show('呀！断网了！！！', 'long', 'center');
                })

            }, false);
        });

        // console.log((new Date).valueOf());
        var token = locals.get('token', false);
        var token_expires = locals.get('token_expires', false);
        if (token != false && token_expires != false) {
            if (parseInt((new Date).valueOf() / 1000) < parseInt(token_expires)) {
                $rootScope.isLogin = true;
            } else {
                $rootScope.isLogin = false;
            }
        }

        $rootScope.collects = [];

        $rootScope.showSearchBtn = false;
        // 显示搜索按钮
        var showSearchBtn = ['app.home', 'app.category'];
        // 登陆验证
        var needLogin = ['app.user', 'app.orders', 'app.coupon', 'app.address', 'app.profile', 'app.checkout'];
        $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams, options) {
            // 登陆验证
            if (needLogin.indexOf(toState.name) >= 0 && !$rootScope.isLogin) {
                $state.go("app.login"); //跳转到登录页
                event.preventDefault(); //阻止默认事件，即原本页面的加载
            }
            // 显示搜索按钮
            if (showSearchBtn.indexOf(toState.name) >= 0) {
                $rootScope.showSearchBtn = true;
            } else {
                $rootScope.showSearchBtn = false;
            }
        })

        $ionicModal.fromTemplateUrl('templates/modal/search.html', {
            scope: $rootScope,
            animation: 'slide-in-right'
        }).then(function (modal) {
            $rootScope.search_modal = modal;
        });
        $rootScope.search = function () {
            $rootScope.search_modal.show();
        }

        $rootScope.search_close = function () {
            $rootScope.search_modal.hide();
        }

        $rootScope.search_number = [];

        var device = locals.getObject('device');
        $rootScope.UUID = device.uuid;

        // 执行搜索
        $rootScope.do_search = function (keyword) {
            var device = locals.getObject('device');
            $rootScope.UUID = device.uuid;
            Search.query({ k: keyword }).$promise.then(function (ret) {
                console.log(ret);
                $rootScope.search_list = ret;
                for (var i = 0; i < ret.length; i++) {
                    $rootScope.search_number[ret[i].goods_id] = 0;
                }
            })
        }

        $rootScope.search_plusCart = function (goods_id) {
            var num = parseInt($rootScope.search_number[goods_id]) + 1;
            $rootScope.search_number[goods_id] = num;
            goods_id = parseInt(goods_id);
            Cart.save({
                device_id: $rootScope.UUID
            }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
                // console.log(ret);
                if (!ret.status) {
                    if (parseInt($rootScope.search_number[goods_id]) != 0) {
                        $rootScope.search_number[goods_id] = parseInt($rootScope.search_number[goods_id]) - 1;
                    }
                    // alert(ret.info);
                    $cordovaToast.show(ret.info, 'long', 'center');
                }
                $rootScope.getCarts();
            })
        }

        $rootScope.search_minusCart = function (goods_id) {
            var num = parseInt($rootScope.search_number[goods_id]) - 1;
            if (num < 0) {
                num = 0;
            }
            $rootScope.search_number[goods_id] = num;
            goods_id = parseInt(goods_id);
            Cart.save({
                device_id: $rootScope.UUID
            }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
                if (!ret.status) {
                    if (parseInt($rootScope.search_number[goods_id]) != 0) {
                        $rootScope.search_number[goods_id] = parseInt($rootScope.search_number[goods_id]) + 1;
                    }
                    // alert(ret.info);
                    $cordovaToast.show(ret.info, 'long', 'center');
                }
                $rootScope.getCarts();
            })
        }

        $rootScope.getCarts = function () {
            $rootScope.cart_total_price = 0.00;
            var device = locals.getObject('device');
            $rootScope.UUID = device.uuid;
            Cart.query({ device_id: $rootScope.UUID }, function (carts) {
                // console.log(carts);
                $rootScope.carts = carts;
                for (var i = 0; i < carts.length; i++) {
                    $rootScope.cart_total_price = $rootScope.cart_total_price +
                        parseFloat(carts[i].goods_number) * parseFloat(carts[i].goods_price);
                }
                $rootScope.cart_total_price = '￥' + $rootScope.cart_total_price.toFixed(2);
            })
        }

        $rootScope.search_number = [];
        // 商品详情
        $rootScope.gdetail = function (goods_id) {
            if ($rootScope.search_number[goods_id] == undefined) {
                $rootScope.search_number[goods_id] = 0;
                $rootScope.add_to_cart_show_btn = true;
            } else if ($rootScope.search_number[goods_id] != undefined && $rootScope.search_number[goods_id] != 0) {
                $rootScope.add_to_cart_show_btn = false;
            }

            $ionicModal.fromTemplateUrl('templates/modal/good_detail.html', {
                scope: $rootScope,
            }).then(function (modal) {
                $rootScope.good_detail_modal = modal;

                GoodsDetail.get({ goods_id: goods_id }).$promise.then(function (ret) {
                    console.log(ret);
                    $rootScope.collected = false;
                    if (ret.status == 0) {
                        $cordovaToast.show(ret.info, 'long', 'center');
                    } else {
                        $rootScope.goods_detail = ret;
                        angular.forEach($rootScope.collects, function (data) {
                            if (parseInt(data.goods_id) == parseInt(ret.goods_id)) {
                                $rootScope.collected = true;
                            } else {
                                $rootScope.collected = false;
                            }
                        })
                    }
                })
                $ionicSlideBoxDelegate.update();
                $rootScope.good_detail_modal.show();
            });

        }

        $rootScope.gdetail_close = function () {
            $rootScope.good_detail_modal.hide();
            $rootScope.good_detail_modal.remove();
        }

        // 返回首页
        $rootScope.go_home = function () {
            $rootScope.gdetail_close();
            $state.go('app.home');
        }

        // 返回购物车
        $rootScope.go_cart = function () {
            $rootScope.gdetail_close();
            $rootScope.cart_state = {
                open: true
            }
        }

        $rootScope.add_to_cart_show_btn = true;

        // 详情加入购物车
        $rootScope.add_to_cart = function (goods_id) {
            $rootScope.search_plusCart(goods_id);
            $rootScope.add_to_cart_show_btn = false;
        }

        // 获得收藏夹数据
        $rootScope.get_collects = function () {
            Collect.get({ token: locals.get('token') }).$promise.then(function (ret) {
                if (ret.status == 1) {
                    $rootScope.collects = ret.data;
                }
            })
        }
        $rootScope.get_collects();

        //添加到收藏夹
        $rootScope.add_collect = function (goods_id) {
            Collect.post({ token: locals.get('token') }, { goods_id: goods_id }).$promise.then(function (ret) {
                $cordovaToast.show(ret.info, 'long', 'center');
                if (ret.status == 1) {
                    $rootScope.get_collects();
                    $rootScope.collected = true;
                }
            })
        }

    })

.config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $compileProvider, $ionicNativeTransitionsProvider) {

    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText(true).icon('ion-ios-arrow-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText(true).icon('ion-ios-arrow-left');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('ios');

    //$ionicConfigProvider.views.maxCache(0); //禁用缓存

    $ionicConfigProvider.backButton.text('返回');
    $ionicConfigProvider.form.checkbox('circle');
    // $ionicConfigProvider.backButton.previousTitleText(false);

    $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|tel|file|sms):/);


    $ionicNativeTransitionsProvider.setDefaultOptions({
        duration: 200, // in milliseconds (ms), default 400,
        slowdownfactor: 4, // overlap views (higher number is more) or no overlap (1), default 4
        iosdelay: -1, // ms to wait for the iOS webview to update before animation kicks in, default -1
        androiddelay: -1, // same as above but for Android, default -1
        winphonedelay: -1, // same as above but for Windows Phone, default -1,
        fixedPixelsTop: 44, // the number of pixels of your fixed header, default 0 (iOS and Android)
        fixedPixelsBottom: 49, // the number of pixels of your fixed footer (f.i. a tab bar), default 0 (iOS and Android)
        triggerTransitionEvent: '$ionicView.afterEnter', // internal ionic-native-transitions option
        backInOppositeDirection: false // Takes over default back transition and state back transition to use the opposite direction transition to go back
    });


    // Ionic uses AngularUI Router which uses the concept of states
    // Learn more here: https://github.com/angular-ui/ui-router
    // Set up the various states which the app can be in.
    // Each state's controller can be found in controllers.js
    $stateProvider

    // setup an abstract state for the tabs directive


        .state('app', {
        url: '/app',
        abstract: true,
        templateUrl: 'templates/tabs.html',
        controller: 'appCtrl'
    })

    // Each tab has its own nav history stack:


    .state('app.home', {
        url: '/home',
        nativeTransitions: {
            type: "fade"
        },
        views: {
            'app-home': {
                templateUrl: 'templates/home.html',
                controller: 'homeCtrl'
            }
        }
    })

    .state('app.new', {
        url: '/new',
        views: {
            'app-home': {
                templateUrl: 'templates/new.html',
                controller: 'newCtrl'
            }
        }
    })

    .state('app.best', {
        url: '/best',
        views: {
            'app-home': {
                templateUrl: 'templates/best.html',
                controller: 'bestCtrl'
            }
        }
    })

    .state('app.activity', {
        url: '/activity',
        views: {
            'app-home': {
                templateUrl: 'templates/activity.html',
                controller: 'activityCtrl'
            }
        }
    })

    .state('app.topic', {
        url: '/topic',
        views: {
            'app-home': {
                templateUrl: 'templates/topic.html',
                controller: 'topicCtrl'
            }
        }
    })

    .state('app.topic-detail', {
        url: '/topic/:topic_id',
        views: {
            'app-home': {
                templateUrl: 'templates/topic_detail.html',
                controller: 'topicDetailCtrl'
            }
        }
    })

    .state('app.category', {
        url: '/category',
        cache: true,
        nativeTransitions: {
            type: "fade"
        },
        views: {
            'app-category': {
                templateUrl: 'templates/category.html',
                controller: 'categoryCtrl'
            }
        }
    })

    .state('app.user', {
        url: '/user',
        nativeTransitions: {
            type: "fade"
        },
        cache: true,
        views: {
            'app-user': {
                templateUrl: 'templates/user.html',
                controller: 'userCtrl'
            }
        }
    })

    .state('app.collect', {
        url: '/collect',
        cache: true,
        views: {
            'app-user': {
                templateUrl: 'templates/collect.html',
                controller: 'collectCtrl'
            }
        }
    })

    .state('app.profile', {
        url: '/profile',
        cache: false,
        views: {
            'app-user': {
                templateUrl: 'templates/profile.html',
                controller: 'profileCtrl'
            }
        }
    })

    .state('app.login', {
        url: '/login',
        cache: false,
        views: {
            'app-user': {
                templateUrl: 'templates/login.html',
                controller: 'loginCtrl'
            }
        }
    })

    .state('app.register', {
        url: '/register',
        cache: false,
        views: {
            'app-user': {
                templateUrl: 'templates/register.html',
                controller: 'registerCtrl'
            }
        }
    })

    .state('app.lostPwd', {
        url: '/lostPwd',
        cache: false,
        views: {
            'app-user': {
                templateUrl: 'templates/lostPwd.html',
                controller: 'lostPwdCtrl'
            }
        }
    })

    .state('app.orders', {
        url: '/orders',
        cache: false,
        views: {
            'app-user': {
                templateUrl: 'templates/orders.html',
                controller: 'ordersCtrl'
            }
        }
    })

    .state('app.orders-detail', {
        url: '/orders/:order_id',
        cache: true,
        views: {
            'app-user': {
                templateUrl: 'templates/orders_detail.html',
                controller: 'orderDetailCtrl'
            }
        }
    })

    .state('app.helps', {
        url: '/helps',
        cache: false,
        views: {
            'app-user': {
                templateUrl: 'templates/helps.html',
                controller: 'helpsCtrl'
            }
        }
    })

    .state('app.helps-detail', {
        url: '/helps/:id',
        cache: false,
        views: {
            'app-user': {
                templateUrl: 'templates/helps_detail.html',
                controller: 'helpsDetailCtrl'
            }
        }

    })

    .state('app.coupon', {
        url: '/coupon',
        cache: false,
        views: {
            'app-user': {
                templateUrl: 'templates/coupon.html',
                controller: 'couponCtrl'
            }
        }
    })

    .state('app.address', {
        url: '/address',
        cache: false,
        views: {
            'app-user': {
                templateUrl: 'templates/address.html',
                controller: 'addressCtrl'
            }
        }
    })

    .state('app.checkout-address', {
        url: '/checkout-address',
        cache: false,
        views: {
            'app-order': {
                templateUrl: 'templates/address.html',
                controller: 'addressCtrl'
            }
        }
    })

    .state('app.about', {
        url: '/about',
        views: {
            'app-user': {
                templateUrl: 'templates/about.html',
                controller: 'aboutCtrl'
            }
        }
    })

    .state('app.checkout', {
        url: '/checkout',
        nativeTransitions: {
            type: "fade"
        },
        cache: false,
        views: {
            'app-order': {
                templateUrl: 'templates/checkout.html',
                controller: 'checkoutCtrl'
            }
        }
    })

    .state('app.pay', {
        url: '/pay/:order_id',
        cache: false,
        views: {
            'app-order': {
                templateUrl: 'templates/pay.html',
                controller: 'payCtrl'
            }
        }
    })

    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/app/home');

});
