angular.module('starter.controllers', [])


// 全局控制器
.controller('appCtrl', function ($scope, $rootScope, $ionicModal,
    $cordovaStatusbar, $cordovaToast, $ionicPopup, $state, locals, Cart) {

    // if (ionic.Platform.isWebView()) {
    //     $cordovaStatusbar.overlaysWebView(true);
    //     $cordovaStatusbar.style(1);
    // }

    $scope.number = [];



    $ionicModal.fromTemplateUrl('templates/modal/cart.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.cart = modal;
    });
    $scope.showCart = function () {
        $scope.getCarts();
        $scope.cart.show();
    }

    // $rootScope.showCart = $scope.showCart();
    $scope.closeCart = function () {

        $scope.cart.hide();
    }

    $scope.getCarts = function () {
        $scope.prices = 0.00;
        var device = locals.getObject('device');
        $scope.UUID = device.uuid;
        Cart.query({ device_id: $scope.UUID }, function (carts) {
            // console.log(carts);
            $scope.carts = carts;
            for (var i = 0; i < carts.length; i++) {
                $scope.number[carts[i].goods_id] = parseInt(carts[i].goods_number);
                $scope.prices = parseFloat($scope.prices) + parseFloat(carts[i].goods_number) *
                    parseFloat(carts[i].goods_price);
            }
            $scope.cart_num = carts.length;
            $rootScope.cart_total_price = '￥' + $scope.prices.toFixed(2);
            $scope.prices = $scope.prices.toFixed(2);
            // console.log($rootScope.cart_total_price);
            $scope.$broadcast('scroll.refreshComplete');
        })
    }

    $scope.plusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) + 1;
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            // console.log(ret);
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) - 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    $scope.numberChange = function (goods_id) {
        var num = parseInt($scope.number[goods_id]);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            // console.log(ret);
            if (!ret.status) {
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    $scope.minusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) - 1;
        if (num < 0) {
            num = 0;
        }
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) + 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    // 删除购物车商品
    $scope.delete_cart_good = function (goods_id) {
        var confirmPopup = $ionicPopup.confirm({
            title: '删除购物车商品',
            template: '确定从购物车里删除该商品？',
            cancelText: '取消',
            okText: '删除',
            okType: 'button-assertive'
        });
        confirmPopup.then(function (res) {
            if (res) {
                Cart.save({
                    device_id: $scope.UUID
                }, { goods_id: goods_id, number: 0 }).$promise.then(function (ret) {
                    if (ret.status == 1) {
                        $cordovaToast.show('删除成功', 'long', 'center');
                        $scope.getCarts();
                        $rootScope.cart_total_price = ret.cart_goods_total;
                        $scope.price = ret.cart_goods_total;
                    } else {
                        $cordovaToast.show(ret.info, 'long', 'center');
                    }
                })
            } else {
                console.log('You are not sure');
            }
        });

    }

    // 去结算
    $scope.checkout = function () {
        Cart.query({ device_id: $scope.UUID }, function (carts) {
            if (carts.length <= 0) {
                $cordovaToast.show('购物车里没有商品', 'long', 'center');
                return false;
            } else {
                // $cordovaToast.show('yes', 'long', 'center');
                $scope.closeCart();
                $state.go('app.checkout');
            }
        })
    }

    $scope.doRefresh = function () {
        $scope.getCarts();
    }

    $scope.getCarts();

    $scope.$watch('cart_state', function (n, o) {
        if (n != undefined) {
            if (n.open) {
                $scope.showCart();
            }
        }

    })
})


// 首页控制器
.controller('homeCtrl', function ($scope, $rootScope, $cordovaToast, $ionicSlideBoxDelegate, GoodsHot, Cart, locals, Ads) {

    $scope.hot_number = [];

    $scope.qhot_goods = function () {
        GoodsHot.query({ number: 20 }).$promise.then(function (ret) {
            $scope.hot_goods = ret;
            // console.log(ret);
            for (var i = 0; i < ret.length; i++) {
                $scope.hot_number[ret[i].goods_id] = 0;
            }
            $scope.$broadcast('scroll.refreshComplete');
        })
    }
    $scope.qhot_goods();

    $scope.plusCart = function (goods_id) {
        var num = parseInt($scope.hot_number[goods_id]) + 1;
        $scope.hot_number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            // console.log(ret);
            if (!ret.status) {
                if (parseInt($scope.hot_number[goods_id]) != 0) {
                    $scope.hot_number[goods_id] = parseInt($scope.hot_number[goods_id]) - 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    $scope.minusCart = function (goods_id) {
        var num = parseInt($scope.hot_number[goods_id]) - 1;
        if (num < 0) {
            num = 0;
        }
        $scope.hot_number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
            if (!ret.status) {
                if (parseInt($scope.hot_number[goods_id]) != 0) {
                    $scope.hot_number[goods_id] = parseInt($scope.hot_number[goods_id]) + 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
        })
    }

    $scope.getCarts = function () {
        $scope.prices = 0.00;
        var device = locals.getObject('device');
        $scope.UUID = device.uuid;
        Cart.query({ device_id: $scope.UUID }, function (carts) {
            // console.log(carts);
            $scope.carts = carts;
            for (var i = 0; i < carts.length; i++) {
                $scope.number[carts[i].goods_id] = parseInt(carts[i].goods_number);
                $scope.prices = $scope.prices + parseFloat(carts[i].goods_number) *
                    parseFloat(carts[i].goods_price);
            }
            $scope.cart_num = carts.length;
            $rootScope.cart_total_price = '￥' + $scope.prices.toFixed(2);
        })
    }

    // 获取首页轮播
    Ads.query({ pos: 3, limit: 5 }).$promise.then(function (ret) {
        // console.log(ret);
        $scope.banner = ret;
        $ionicSlideBoxDelegate.update();
    })

    // 获取首页广告
    Ads.query({ pos: 4, limit: 3 }).$promise.then(function (ret) {
        // console.log(ret);
        $scope.ads = ret;
        $ionicSlideBoxDelegate.update();
    })

    $scope.doRefresh = function () {
        $scope.qhot_goods();
    }

})

// 新品上市
.controller('newCtrl', function ($scope, $rootScope, $cordovaToast, GoodsNew, Cart, locals, Ads) {
    // 查询商品
    $scope.get_goods = function () {
        GoodsNew.query({ number: 80 }).$promise.then(function (ret) {
            $scope.goods = ret;
            // console.log(ret);
            for (var i = 0; i < ret.length; i++) {
                $scope.number[ret[i].goods_id] = 0;
            }
            $scope.$broadcast('scroll.refreshComplete');
        })
    }


    // 查询广告
    Ads.get({ pos: 1 }).$promise.then(function (ret) {
        // console.log(ret);
        $scope.ad = ret;
    })


    $scope.plusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) + 1;
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            // console.log(ret);
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) - 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    $scope.minusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) - 1;
        if (num < 0) {
            num = 0;
        }
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) + 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
        })
    }

    $scope.getCarts = function () {
        $scope.prices = 0.00;
        var device = locals.getObject('device');
        $scope.UUID = device.uuid;
        Cart.query({ device_id: $scope.UUID }, function (carts) {
            // console.log(carts);
            $scope.carts = carts;
            for (var i = 0; i < carts.length; i++) {
                $scope.number[carts[i].goods_id] = parseInt(carts[i].goods_number);
                $scope.prices = $scope.prices + parseFloat(carts[i].goods_number) *
                    parseFloat(carts[i].goods_price);
            }
            $scope.cart_num = carts.length;
            $rootScope.cart_total_price = '￥' + $scope.prices.toFixed(2);
        })
    }

    $scope.get_goods();
    $scope.doRefresh = function () {
        $scope.get_goods();
    }
})

// 精品热卖
.controller('bestCtrl', function ($scope, $rootScope, $cordovaToast, GoodsBest, Cart, locals, Ads) {
    // 查询商品
    $scope.get_goods = function () {
        GoodsBest.query({ number: 80 }).$promise.then(function (ret) {
            $scope.goods = ret;
            for (var i = 0; i < ret.length; i++) {
                $scope.number[ret[i].goods_id] = 0;
            }
            $scope.$broadcast('scroll.refreshComplete');
        })
    }


    // 查询广告
    Ads.get({ pos: 2 }).$promise.then(function (ret) {
        // console.log(ret);

        $scope.ad = ret;
        // console.log(ret.ad_link);
    })


    $scope.plusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) + 1;
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            // console.log(ret);
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) - 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    $scope.minusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) - 1;
        if (num < 0) {
            num = 0;
        }
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) + 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
        })
    }

    $scope.getCarts = function () {
        $scope.prices = 0.00;
        var device = locals.getObject('device');
        $scope.UUID = device.uuid;
        Cart.query({ device_id: $scope.UUID }, function (carts) {
            // console.log(carts);
            $scope.carts = carts;
            for (var i = 0; i < carts.length; i++) {
                $scope.number[carts[i].goods_id] = parseInt(carts[i].goods_number);
                $scope.prices = $scope.prices + parseFloat(carts[i].goods_number) *
                    parseFloat(carts[i].goods_price);
            }
            $scope.cart_num = carts.length;
            $rootScope.cart_total_price = '￥' + $scope.prices.toFixed(2);
        })
    }

    $scope.get_goods();
    $scope.doRefresh = function () {
        $scope.get_goods();
    }
})


// 优惠活动
.controller('activityCtrl', function ($scope, $rootScope, $cordovaToast, Cart, locals, Activity, Ads) {
    $scope.getActivity = function () {
        Activity.query().$promise.then(function (ret) {
            // console.log(ret);
            $scope.activity = ret;
            $scope.$broadcast('scroll.refreshComplete');
            for (var i = 0; i < ret.length; i++) {
                for (var j = 0; j < ret[i].good_lists.length; j++) {
                    $scope.number[ret[i].good_lists[j].goods_id] = 0;
                }
            }
            // console.log($scope.number);
        })
    }

    // 查询广告
    Ads.get({ pos: 2 }).$promise.then(function (ret) {
        // console.log(ret);

        $scope.ad = ret;
        // console.log(ret.ad_link);
    })


    $scope.plusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) + 1;
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            // console.log(ret);
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) - 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    $scope.minusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) - 1;
        if (num < 0) {
            num = 0;
        }
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) + 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
        })
    }

    $scope.getCarts = function () {
        $scope.prices = 0.00;
        var device = locals.getObject('device');
        $scope.UUID = device.uuid;
        Cart.query({ device_id: $scope.UUID }, function (carts) {
            // console.log(carts);
            $scope.carts = carts;
            for (var i = 0; i < carts.length; i++) {
                $scope.number[carts[i].goods_id] = parseInt(carts[i].goods_number);
                $scope.prices = $scope.prices + parseFloat(carts[i].goods_number) *
                    parseFloat(carts[i].goods_price);
            }
            $scope.cart_num = carts.length;
            $rootScope.cart_total_price = '￥' + $scope.prices.toFixed(2);
        })
    }

    $scope.getActivity();
    $scope.doRefresh = function () {
        $scope.getActivity();
    }
})


// 专题
.controller('topicCtrl', function ($scope, Topic) {
    $scope.getTopic = function () {
        Topic.query().$promise.then(function (ret) {
            // console.log(ret);
            $scope.topics = ret;
            $scope.$broadcast('scroll.refreshComplete');
        })
    }
    $scope.getTopic();
    $scope.doRefresh = function () {
        $scope.getTopic();
    }
})

// 专题详情
.controller('topicDetailCtrl', function ($scope, $rootScope, $cordovaToast, $stateParams, $state, Topic, Cart, locals) {
    var topic_id = $stateParams.topic_id;
    $scope.getTopic = function () {
        Topic.get({ topic_id: topic_id }).$promise.then(function (ret) {
            // console.log(ret);
            if (ret.status == 1) {
                $scope.topic = ret.data;
                for (var j = 0; j < ret.data.goods.length; j++) {
                    $scope.number[ret.data.goods[j].goods_id] = 0;
                }
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
                $state.go('app.topic');
            }
            $scope.$broadcast('scroll.refreshComplete');
        })
    }

    $scope.plusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) + 1;
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            // console.log(ret);
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) - 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    $scope.minusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) - 1;
        if (num < 0) {
            num = 0;
        }
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) + 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
        })
    }

    $scope.getCarts = function () {
        $scope.prices = 0.00;
        var device = locals.getObject('device');
        $scope.UUID = device.uuid;
        Cart.query({ device_id: $scope.UUID }, function (carts) {
            // console.log(carts);
            $scope.carts = carts;
            for (var i = 0; i < carts.length; i++) {
                $scope.number[carts[i].goods_id] = parseInt(carts[i].goods_number);
                $scope.prices = $scope.prices + parseFloat(carts[i].goods_number) *
                    parseFloat(carts[i].goods_price);
            }
            $scope.cart_num = carts.length;
            $rootScope.cart_total_price = '￥' + $scope.prices.toFixed(2);
        })
    }

    $scope.getTopic();
    $scope.doRefresh = function () {
        $scope.getTopic();
    }
})


// 商品分类
.controller('categoryCtrl', function ($rootScope, $scope, $ionicPopup,
    $cordovaToast, Category, Goods, Cart, locals) {
    var device = locals.getObject('device');
    $scope.UUID = device.uuid;

    // $cordovaToast.show($scope.UUID, 'long', 'center');

    // console.log($scope.UUID);
    $scope.is_open = 0
    $scope.page = 1;
    $scope.moreDataCanBeLoaded = false;
    $scope.number = [];


    Category.query(function (ret) {
            $scope.categorys = ret;
            $scope.qgoods(ret[$scope.is_open].cat_id, 1);
            // console.log(ret);
        })
        // console.log($scope.categorys);

    $scope.toggle = function (index) {
        $scope.is_open = index;
        $scope.queryGoods($scope.categorys[index].cat_id);
    }

    $scope.qgoods = function (cid, page) {
        $scope.active_cat_id = cid;
        $scope.page = page;
        Goods.query({ cid: cid, p: page }, function (goods) {
            // console.log(goods);
            $scope.goods = goods;
            for (var i = 0; i < goods.length; i++) {
                $scope.number[goods[i].goods_id] = 0;
            }
            if (goods.length == 0) {
                $scope.moreDataCanBeLoaded = false;
            } else {
                $scope.moreDataCanBeLoaded = true;
            }

            $scope.$broadcast('scroll.refreshComplete');
        })
    }

    $scope.queryGoods = function (cid) {
        $scope.qgoods(cid, 1);

    }

    $scope.doRefresh = function () {
        $scope.qgoods($scope.categorys[$scope.is_open].cat_id, 1);
    }

    $scope.loadMore = function () {
        $scope.page = $scope.page + 1;
        Goods.query({ cid: $scope.categorys[$scope.is_open].cat_id, p: $scope.page }, function (goods) {
            // console.log(goods.length);
            if (goods.length == 0) {
                $scope.moreDataCanBeLoaded = false;
                $scope.$broadcast('scroll.refreshComplete');
            } else {
                $scope.goods = $scope.goods.concat(goods);

                for (var i = 0; i < goods.length; i++) {
                    $scope.number[goods[i].goods_id] = 0;
                }

                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }
        })
    }

    $scope.plusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) + 1;
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            // console.log(ret);
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) - 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    $scope.minusCart = function (goods_id) {
        var num = parseInt($scope.number[goods_id]) - 1;
        if (num < 0) {
            num = 0;
        }
        $scope.number[goods_id] = num;
        goods_id = parseInt(goods_id);
        Cart.save({
            device_id: $scope.UUID
        }, { goods_id: goods_id, number: num }).$promise.then(function (ret) {
            if (!ret.status) {
                if (parseInt($scope.number[goods_id]) != 0) {
                    $scope.number[goods_id] = parseInt($scope.number[goods_id]) + 1;
                }
                // alert(ret.info);
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.getCarts();
            $rootScope.cart_total_price = ret.cart_goods_total;
            $scope.price = ret.cart_goods_total;
        })
    }

    $scope.getCarts = function () {
        $scope.cart_total_price = 0.00;
        var device = locals.getObject('device');
        $scope.UUID = device.uuid;
        Cart.query({ device_id: $scope.UUID }, function (carts) {
            // console.log(carts);
            $scope.carts = carts;
            for (var i = 0; i < carts.length; i++) {
                $scope.cart_total_price = $scope.cart_total_price +
                    parseFloat(carts[i].goods_number) * parseFloat(carts[i].goods_price);
            }
            $rootScope.cart_total_price = '￥' + $scope.cart_total_price.toFixed(2);
        })
    }

})

// 个人中心
.controller('userCtrl', function ($scope, $rootScope, $ionicHistory,
    $ionicNavBarDelegate, $cordovaToast, $state, locals, User, $window,
    ProfileCounts, SystemConfig) {
    // 隐藏返回按钮
    $ionicNavBarDelegate.showBackButton(false);
    $ionicHistory.removeBackView();
    $ionicHistory.clearHistory();

    $scope.counts = {
        'order': '0',
        'bonus': '0'
    }

    // 用户退出登陆
    $scope.logout = function () {
        $window.localStorage.clear();
        $rootScope.isLogin = false;
        $state.go("app.login");
    }

    // 本地存储的用户信息
    var user_info = locals.getObject('user_info');
    if (user_info.length <= 0) {
        $scope.get_user_info();
    } else {
        $scope.user = user_info;
    }

    // 获取用户信息
    $scope.get_user_info = function () {
        User.query({ token: locals.get('token') }).$promise.then(function (ret) {
            // console.log(ret);
            if (ret.status == 1) {
                $scope.user = ret.user;
                locals.setObject('user_info', ret.user);
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.$broadcast('scroll.refreshComplete');
        })
    }

    // 获取订单和优惠券统计信息
    $scope.get_counts = function () {
        ProfileCounts.get({ token: locals.get('token') }).$promise.then(function (ret) {
            // console.log(ret);
            if (ret.status == 1) {
                $scope.counts = ret.counts
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.$broadcast('scroll.refreshComplete');
        })
    }
    $scope.get_counts();

    // 获取服务电话
    $scope.get_service_phone = function () {
        SystemConfig.get({ code: 'service_phone' }).$promise.then(function (ret) {
            if (ret.status == 1) {
                $scope.service_phone = ret.data;
            }
        })
    }
    $scope.get_service_phone();

    // 下拉刷新
    $scope.doRefresh = function () {
        $scope.get_user_info();
        $scope.get_counts();
        $scope.get_service_phone();
    }

    // 切换页面时显示返回
    $rootScope.$on('$stateChangeStart', function (event, toState, toParams,
        fromState, fromParams, options) {
        $ionicNavBarDelegate.showBackButton(true);
    })
})


// 用户收藏夹
.controller('collectCtrl', function ($scope, $rootScope, Cart, $cordovaToast) {
    $scope.doRefresh = function () {
        $rootScope.get_collects();
        $scope.$broadcast('scroll.refreshComplete');
    }

    $scope.add_to_cart = function (goods_id) {
        Cart.save({
            device_id: $rootScope.UUID
        }, { goods_id: goods_id, number: 1 }).$promise.then(function (ret) {
            $cordovaToast.show(ret.info, 'long', 'center');
            $rootScope.getCarts();
        })
    }
})


// 用户登陆
.controller('loginCtrl', function ($scope, $rootScope, $cordovaToast,
    $ionicNavBarDelegate, $ionicHistory, $state, User, locals) {
    $scope.user = {};

    // 隐藏返回按钮
    $ionicNavBarDelegate.showBackButton(false);
    $ionicHistory.removeBackView();
    $ionicHistory.clearHistory();

    $scope.doLogin = function () {
        if ($scope.user.name == undefined || $scope.user.name.length < 4) {
            $cordovaToast.show('用户名不能为空', 'long', 'center');
            return false;
        }
        if ($scope.user.password == undefined || $scope.user.password.length < 6) {
            $cordovaToast.show('登陆密码不能为空', 'long', 'center');
            return false;
        }

        var device = locals.getObject('device')
            // console.log(device);
        User.login({
            token: '',
            username: $scope.user.name,
            password: $scope.user.password,
            uuid: device.uuid,
        }).$promise.then(function (ret) {
            if (ret.status == 1) {
                locals.setObject('user_info', ret.user);
                locals.set('token', ret.token);
                locals.set('token_expires', ret.expires);
                $rootScope.isLogin = true;
                $cordovaToast.show(ret.info, 'long', 'center');
                $ionicHistory.removeBackView();
                $ionicHistory.clearHistory();
                $state.go("app.user");
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
            }
        })

        // console.log($scope.user);
    }
})

// 用户注册
.controller('registerCtrl', function ($scope, $rootScope, $cordovaToast,
    $ionicHistory, $state, User, locals, SmsCode) {
    $scope.user = {
        name: ''
    };

    // 验证手机号码
    $scope.validatemobile = function (mobile) {
        if (mobile.length != 11) {
            $cordovaToast.show('请输入有效的手机号码', 'long', 'center');
            return false;
        }
        var myreg = /^((1[3,5,8][0-9])|(14[5,7])|(17[0,1,6,7,8]))\d{8}$/;
        if (!myreg.test(mobile)) {
            $cordovaToast.show('请输入有效的手机号码', 'long', 'center');
            return false;
        }
        return true;
    }

    // 获取短信验证码
    $scope.get_sms_code = function () {
        // if ($scope.validatemobile($scope.user.name)) {
        //     $scope.verify_code = 888888;
        //     $cordovaToast.show('测试验证码：888888', 'long', 'center');
        // }
        if ($scope.validatemobile($scope.user.name)) {
            SmsCode.get({ phone: $scope.user.name }).$promise.then(function (ret) {
                $cordovaToast.show(ret.info, 'long', 'center');
                if (ret.status == 1) {
                    $scope.verify_code = ret.code;
                    $scope.code_phone = ret.code_phone;
                }
            })
        }
    }

    // 注册操作
    $scope.doRegister = function () {
        // console.log($scope.user);
        if ($scope.user.name == undefined || $scope.user.name.length < 4) {
            $cordovaToast.show('用户名不能为空', 'long', 'center');
            return false;
        }
        if ($scope.user.password == undefined || $scope.user.password.length < 6) {
            $cordovaToast.show('登陆密码不能为空', 'long', 'center');
            return false;
        }
        if ($scope.user.password != $scope.user.re_password) {
            $cordovaToast.show('两次输入的密码不一致', 'long', 'center');
            return false;
        }
        if ($scope.user.names == undefined) {
            $cordovaToast.show('联系人不能为空', 'long', 'center');
            return false;
        }
        if ($scope.user.address == undefined) {
            $cordovaToast.show('收货地址不能为空', 'long', 'center');
            return false;
        }
        if ($scope.user.verify_code == undefined || $scope.user.verify_code.toString().length != 6) {
            $cordovaToast.show('填写正确的短信验证码', 'long', 'center');
            return false;
        }

        if ($scope.user.verify_code != $scope.verify_code) {
            $cordovaToast.show('短信验证码不正确', 'long', 'center');
            return false;
        } else if ($scope.code_phone != $scope.user.name) {
            $cordovaToast.show('短信验证码不正确', 'long', 'center');
            return false;
        }

        if (!$scope.validatemobile($scope.user.name)) {
            return false;
        }
        var device = locals.getObject('device')

        User.register({
            token: '',
            username: $scope.user.name,
            password: $scope.user.password,
            names: $scope.user.names,
            address: $scope.user.address,
            uuid: device.uuid
        }).$promise.then(function (ret) {
            if (ret.status == 1) {
                // 保存登陆状态
                locals.setObject('user_info', ret.user);
                locals.set('token', ret.token);
                locals.set('token_expires', ret.expires);
                $rootScope.isLogin = true;
                $cordovaToast.show(ret.info, 'long', 'center');
                $ionicHistory.removeBackView();
                $ionicHistory.clearHistory();
                $state.go("app.user");
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
            }
        })

    }
})

// 忘记密码
.controller('lostPwdCtrl', function ($scope, $cordovaToast,
    $ionicHistory, $state, User, locals, SmsCode) {
    $scope.user = {
        name: ''
    };

    // 验证手机号码
    $scope.validatemobile = function (mobile) {
            if (mobile.length != 11) {
                $cordovaToast.show('请输入有效的手机号码', 'long', 'center');
                return false;
            }
            var myreg = /^((1[3,5,8][0-9])|(14[5,7])|(17[0,1,6,7,8]))\d{8}$/;
            if (!myreg.test(mobile)) {
                $cordovaToast.show('请输入有效的手机号码', 'long', 'center');
                return false;
            }
            return true;
        }
        // 获取短信验证码
    $scope.get_sms_code = function () {
        // if ($scope.validatemobile($scope.user.name)) {
        //     $scope.verify_code = 888888;
        //     $cordovaToast.show('测试验证码：888888', 'long', 'center');
        // }
        if ($scope.validatemobile($scope.user.name)) {
            SmsCode.get({ phone: $scope.user.name }).$promise.then(function (ret) {
                $cordovaToast.show(ret.info, 'long', 'center');
                if (ret.status == 1) {
                    $scope.verify_code = ret.code;
                    $scope.code_phone = ret.code_phone;
                }
            })
        }
    }

    $scope.doLostPwd = function () {
        if ($scope.user.name == undefined || $scope.user.name.length < 4) {
            $cordovaToast.show('用户名不能为空', 'long', 'center');
            return false;
        }
        if ($scope.user.password == undefined || $scope.user.password.length < 6) {
            $cordovaToast.show('新密码不能为空', 'long', 'center');
            return false;
        }
        if ($scope.user.password != $scope.user.re_password) {
            $cordovaToast.show('两次输入的密码不一致', 'long', 'center');
            return false;
        }

        if ($scope.user.verify_code == undefined || $scope.user.verify_code.toString().length != 6) {
            $cordovaToast.show('填写正确的短信验证码', 'long', 'center');
            return false;
        }

        if ($scope.user.verify_code != $scope.verify_code) {
            $cordovaToast.show('短信验证码不正确', 'long', 'center');
            return false;
        } else if ($scope.code_phone != $scope.user.name) {
            $cordovaToast.show('短信验证码不正确', 'long', 'center');
            return false;
        }
        User.save({ token: '' }, { username: $scope.user.name, password: $scope.user.password })
            .$promise.then(function (ret) {
                $cordovaToast.show(ret.info, 'long', 'center');
                if (ret.status == 1) {
                    $ionicHistory.removeBackView();
                    $ionicHistory.clearHistory();
                    $state.go("app.login");
                }
            })
    }
})

// 帮助中心
.controller('helpsCtrl', function ($scope, Articles, $cordovaToast) {
    $scope.get_helps = function () {
        Articles.get({ cat_id: 13 }).$promise.then(function (ret) {
            // console.log(ret);
            if (ret.status == 1) {
                $scope.helps = ret.data;
                $scope.$broadcast('scroll.refreshComplete');
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
            }
        })
    }
    $scope.get_helps();

    $scope.doRefresh = function () {
        $scope.get_helps();
    }
})

// 帮助详情页面
.controller('helpsDetailCtrl', function ($scope, $stateParams, Articles, $cordovaToast) {
    Articles.get({ id: $stateParams.id }).$promise.then(function (ret) {
        if (ret.status == 1) {
            // console.log(ret);
            $scope.article = ret.data;
            $scope.header_title = $scope.article.title;
        } else {
            $cordovaToast.show(ret.info, 'long', 'center');
        }
    })
})

// 关于我们
.controller('aboutCtrl', function ($scope, Articles, $cordovaToast) {
    Articles.get({ id: 4 }).$promise.then(function (ret) {
        if (ret.status == 1) {
            $scope.article = ret.data;
        } else {
            $cordovaToast.show(ret.info, 'long', 'center');
        }
    })
})

// 优惠券
.controller('couponCtrl', function ($scope, $cordovaToast, $ionicPopup, Coupon, locals) {
    $scope.search = function () {
        Coupon.get({ token: locals.get('token') }).$promise.then(function (ret) {
            // console.log(ret);
            if (ret.status == 1) {
                $scope.coupon = ret.coupon;
                $scope.$broadcast('scroll.refreshComplete');
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.$broadcast('scroll.refreshComplete');
        })
    }
    $scope.search();

    $scope.add = function () {
        $ionicPopup.prompt({
            title: '添加优惠券',
            template: '&nbsp;',
            inputType: 'text',
            inputPlaceholder: '输入获得的优惠券号码',
            cancelText: '取消',
            okText: '确定',
            okType: 'balanced'
        }).then(function (res) {
            if (res != undefined) {
                if (res != '') {
                    Coupon.add({ token: locals.get('token') }, {
                        bonus_sn: res
                    }).$promise.then(function (ret) {
                        if (ret.status == 1) {
                            $scope.search();
                        }
                        $cordovaToast.show(ret.info, 'long', 'center');
                    });
                }
            }
        });
    }

    $scope.doRefresh = function () {
        $scope.search();
    }
})

// 添加收货地址
.controller('addressCtrl', function ($scope, $cordovaToast, $ionicModal, $ionicScrollDelegate, Address, locals, Region) {
    $scope.address = {
        country: 0,
        province: 0,
        city: 0,
        district: 0
    };
    // 获取收货地址
    $scope.get_address = function () {
        Address.get({ token: locals.get('token') }).$promise.then(function (ret) {
            // console.log(ret);
            $scope.address_list = ret.address;
            $scope.$broadcast('scroll.refreshComplete');
        })
    }
    $scope.get_address();


    // 添加收货地址
    $ionicModal.fromTemplateUrl('templates/modal/address.html', {
        scope: $scope,
        animation: 'slide-in-right'
    }).then(function (modal) {
        $scope.modal = modal;
    });
    $scope.add_address = function () {
        $scope.address = {
            country: 0,
            province: 0,
            city: 0,
            district: 0
        };
        $scope.action = 'add';
        $scope.title = '新增地址';
        $scope.modal.show();
    }

    $scope.edit_address = function (address_id) {
        $scope.address_id = address_id;
        Address.get({ token: locals.get('token'), address_id: address_id }).$promise.then(function (ret) {
            // console.log(ret);
            ret.address.zipcode = parseInt(ret.address.zipcode);
            $scope.address = ret.address;
            $scope.$broadcast('scroll.refreshComplete');
        })
        $scope.action = 'edit';
        $scope.title = '编辑地址';
        $scope.modal.show();
    }

    // 关闭窗口
    $scope.close = function () {
        $scope.modal.hide();
    }


    // 区域选择
    $ionicModal.fromTemplateUrl('templates/modal/region.html', {
        scope: $scope,
        animation: 'slide-in-right'
    }).then(function (modal) {
        $scope.region = modal;
    });
    $scope.select_region = function (pid, name, level) {
        switch (level) {
        case 0:
            $scope.address.country = pid;
            $scope.address.country_name = name;
            break;
        case 1:
            $scope.address.province = pid;
            $scope.address.province_name = name;
            break;
        case 2:
            $scope.address.city = pid;
            $scope.address.city_name = name;
            break;
        case 3:
            $scope.address.district = pid;
            $scope.address.district_name = name;
            break;
        }
        // console.log($scope.address);

        $scope.level = parseInt(level) + 1;

        Region.query({ pid: pid }).$promise.then(function (ret) {
            // console.log(ret);
            $scope.regions = ret;
            if (ret.length <= 0) {
                $scope.close_region();
            }
            $ionicScrollDelegate.scrollTop();
        })
        $scope.region.show();
    }

    $scope.close_region = function () {
        $scope.region.hide();
    }

    // 下拉刷新
    $scope.doRefresh = function () {
        $scope.get_address();
    }

    // 删除地址
    $scope.delete = function (id) {
        Address.delete({ token: locals.get('token'), address_id: id }).$promise.then(function (ret) {
            if (ret.status == 1) {
                $scope.close();
                $scope.get_address();
            }
            $cordovaToast.show(ret.info, 'long', 'center');
        })
    }

    // 保存
    $scope.save = function () {

        // console.log($scope.address);
        if ($scope.address.consignee == '' || $scope.address.consignee == undefined) {
            $cordovaToast.show('联系人不能为空', 'long', 'center');
            return false;
        }
        if ($scope.address.tel == '' || $scope.address.tel == undefined) {
            $cordovaToast.show('电话号码不能为空', 'long', 'center');
            return false;
        }
        if ($scope.address.country == 0 || $scope.address.province == 0) {
            $cordovaToast.show('请选择所在区域', 'long', 'center');
            return false;
        }
        if ($scope.address.address == '' || $scope.address.address == undefined) {
            $cordovaToast.show('详细地址不能为空', 'long', 'center');
            return false;
        }

        var data = {
                consignee: $scope.address.consignee,
                tel: $scope.address.tel,
                zipcode: $scope.address.zipcode,
                country: $scope.address.country,
                province: $scope.address.province,
                city: $scope.address.city,
                district: $scope.address.district,
                address: $scope.address.address,
            }
            // console.log(data);

        if ($scope.action == 'add') {
            Address.add({ token: locals.get('token') }, data).$promise.then(function (ret) {
                if (ret.status == 1) {
                    $scope.close();
                    $scope.get_address();
                }
                $cordovaToast.show(ret.info, 'long', 'center');
            })
        } else if ($scope.action == 'edit') {
            data.address_id = $scope.address_id;
            Address.edit({ token: locals.get('token') }, data).$promise.then(function (ret) {
                if (ret.status == 1) {
                    $scope.close();
                    $scope.get_address();
                }
                $cordovaToast.show(ret.info, 'long', 'center');
            })
        }
    }
})

// 个人资料修改页面
.controller('profileCtrl', function ($scope, $cordovaCamera, $ionicActionSheet,
    $cordovaToast, $ionicPopup, Avatar, locals, User) {
    $scope.profile = {
        avatar: ''
    }

    // 获取用户信息
    $scope.user_info = function () {
        User.query({ token: locals.get('token') }).$promise.then(function (ret) {
            // console.log(ret);
            if (ret.status == 1) {
                $scope.profile = ret.user;
                locals.setObject('user_info', ret.user);
            }
        })
    }
    $scope.user_info();

    // 修改头像
    $scope.selectImg = function () {
        var hideSheet = $ionicActionSheet.show({
            buttons: [{
                text: '相册'
            }, {
                text: '拍照'
            }],
            titleText: '选择头像',
            cancelText: '取消',
            cancel: function () {
                // add cancel code..
            },
            buttonClicked: function (index) {

                var options = {
                    quality: 50,
                    destinationType: Camera.DestinationType.DATA_URL,
                    sourceType: index,
                    allowEdit: true,
                    encodingType: Camera.EncodingType.JPEG,
                    targetWidth: 200,
                    targetHeight: 200,
                    saveToPhotoAlbum: false,
                    correctOrientation: true
                };

                $cordovaCamera.getPicture(options).then(function (imageData) {
                    $scope.profile.avatar = imageData;
                    // $cordovaToast.show(imageData, 'long', 'center');
                    // console.log(imageData);

                    Avatar.post({
                        token: locals.get('token'),
                        avatar: imageData
                    }).$promise.then(function (ret) {
                        if (ret.status == 1) {
                            User.query({ token: locals.get('token') }).$promise.then(function (ret) {
                                // console.log(ret);
                                if (ret.status == 1) {
                                    $scope.user = ret.user;
                                    locals.setObject('user_info', ret.user);
                                    hideSheet();
                                }
                            })
                            hideSheet();
                        }
                        $cordovaToast.show(ret.info, 'long', 'center');
                        // console.log(ret);
                    })

                }, function (err) {
                    $cordovaToast.show('系统相机访问失败', 'long', 'center');
                });

            }
        });
    }

    // 修改用户名
    $scope.edit_username = function () {
        $cordovaToast.show('不允许修改用户名', 'long', 'center');
    }

    // 修改姓名
    $scope.edit_names = function () {
        $ionicPopup.prompt({
            title: '修改姓名',
            template: '输入姓名',
            inputType: 'text',
            inputPlaceholder: '输入姓名',
            cancelText: '取消',
            okText: '确定',
            okType: 'balanced'
        }).then(function (res) {
            if (res != $scope.profile.names) {
                User.save({ token: locals.get('token') }, {
                    names: res,
                }).$promise.then(function (ret) {
                    $cordovaToast.show(ret.info, 'long', 'center');
                    $scope.user_info();
                })
            } else {
                $cordovaToast.show('没有任何改变', 'long', 'center');
            }
        });
    }

    // 修改邮箱
    $scope.edit_email = function () {
        $ionicPopup.prompt({
            title: '修改邮箱',
            template: '输入邮箱',
            inputType: 'email',
            inputPlaceholder: '输入邮箱',
            cancelText: '取消',
            okText: '确定',
            okType: 'balanced'
        }).then(function (res) {
            if (res != $scope.profile.email) {
                User.save({ token: locals.get('token') }, {
                    email: res,
                }).$promise.then(function (ret) {
                    $cordovaToast.show(ret.info, 'long', 'center');
                    $scope.user_info();
                })
            } else {
                $cordovaToast.show('没有任何改变', 'long', 'center');
            }
        });
    }

    // 修改性别
    $scope.edit_sex = function () {
        var hideSheet = $ionicActionSheet.show({
            buttons: [{
                text: '女士'
            }, {
                text: '男士'
            }],
            titleText: '选择性别',
            cancelText: '取消',
            cancel: function () {
                // add cancel code..
            },
            buttonClicked: function (index) {
                if (index != $scope.profile.sex) {
                    User.save({ token: locals.get('token') }, {
                        sex: index,
                    }).$promise.then(function (ret) {
                        $cordovaToast.show(ret.info, 'long', 'center');
                        $scope.user_info();
                        hideSheet();
                    })
                } else {
                    $cordovaToast.show('没有任何改变', 'long', 'center');
                    hideSheet();
                }
            }
        });
    }
})

// 我的订单
.controller('ordersCtrl', function ($scope, $cordovaToast, $state, Orders, locals) {
    $scope.order_status = 'all';

    $scope.order_lists = function () {
        Orders.get({
            token: locals.get('token'),
            status: $scope.order_status
        }).$promise.then(function (ret) {
            // console.log(ret);
            if (ret.status == 1) {
                $scope.orders = ret.orders;
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.$broadcast('scroll.refreshComplete');
        });
    }

    $scope.order_lists();
    // 修改查询状态订单
    $scope.query_status = function (status) {
        $scope.order_status = status;
        $scope.order_lists();
    }

    // 跳到详情页
    $scope.detail = function (order_id) {
        $state.go('app.orders-detail', { order_id: order_id });
    }

    // 下拉刷新
    $scope.doRefresh = function () {
        $scope.order_lists();
    }
})

// 订单详情
.controller('orderDetailCtrl', function ($scope, $rootScope, $cordovaToast, $interval, $state, $stateParams, Orders, locals) {
    var order_id = $stateParams.order_id;
    $scope.is_can_pay = false;
    $scope.status_name = '待支付';
    $scope.to = {
        d: 0,
        h: 0,
        m: 0,
        s: 0
    };
    // 获取订单信息
    $scope.get_order = function () {
        Orders.query({ token: locals.get('token'), order_id: order_id }).$promise.then(function (ret) {
            if (ret.status == 1) {
                $scope.order = ret.data;
                $scope.status_name = ret.data.status_name;
                if (ret.data.status_name == '待支付') {
                    $scope.is_can_pay = true;
                }
                if (ret.data.pay_id == 5) {
                    $scope.is_can_pay = false;
                }
                if (ret.data.auto_cancle_time != undefined) {
                    var time = (new Date()).valueOf();
                    if (parseInt(ret.data.auto_cancle_time) < time) {
                        $scope.is_can_pay = false;
                    }
                    $scope.inter = $interval(function () {
                        time = (new Date()).valueOf();
                        // console.log(time);
                        if (parseInt(ret.data.auto_cancle_time) < time) {
                            $scope.is_can_pay = false;
                            if (ret.data.status_name == '待支付') {
                                $scope.cancel(order_id);
                            }

                            // console.log(parseInt(ret.data.auto_cancle_time));
                            $interval.cancel($scope.inter);
                            // $cordovaToast.show('订单已超时取消', 'long', 'center');
                            $scope.to = {
                                d: 0,
                                h: 0,
                                m: 0,
                                s: 0
                            };
                            return;
                        }

                        // 倒计时
                        var date = new Date();
                        var nowDate = new Date();
                        date.setTime(ret.data.auto_cancle_time);
                        var t = date.getTime() - nowDate.getTime();
                        $scope.to.d = pad(Math.floor(t / 1000 / 60 / 60 / 24), 2);
                        $scope.to.h = pad(Math.floor(t / 1000 / 60 / 60 % 24), 2);
                        $scope.to.m = pad(Math.floor(t / 1000 / 60 % 60), 2);
                        $scope.to.s = pad(Math.floor(t / 1000 % 60), 2);

                        function pad(num, n) {
                            var len = num.toString().length;
                            while (len < n) {
                                num = "0" + num;
                                len++;
                            }
                            return num;
                        }
                    }, 1000);
                }
                // console.log(ret.data);
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
            }
            $scope.$broadcast('scroll.refreshComplete');
        })
    }

    $scope.get_order();

    // 下拉刷新
    $scope.doRefresh = function () {
        $scope.get_order();
    }

    // 取消订单
    $scope.cancel = function (order_id) {
        Orders.delete({ token: locals.get('token'), order_id: order_id }).$promise.then(function (ret) {
            $cordovaToast.show(ret.info, 'long', 'center');
            if (ret.status == 1) {
                $scope.get_order();
            }
        })
    }

    // 确认收货
    $scope.done = function (order_id) {
        Orders.done({ token: locals.get('token'), order_id: order_id }).$promise.then(function (ret) {
            $cordovaToast.show(ret.info, 'long', 'center');
            if (ret.status == 1) {
                $scope.get_order();
            }
        })
    }

    // 调起支付订单
    $scope.pay = function () {
        if (!$scope.is_can_pay) {
            return false;
        }
        var charge = $scope.order.charge;
        try {
            pingpp.createPayment(charge, function (result) {
                // console.log(result);
                if (result == 'success') {
                    $cordovaToast.show('支付成功', 'long', 'center');
                    $rootScope.cart_total_price = '￥0.00';
                    $scope.get_order();
                    $scope.is_can_pay = false;
                } else {
                    if (result == 'cancle') {
                        $cordovaToast.show('取消支付', 'long', 'center');
                    } else if (result == 'fail') {
                        $cordovaToast.show('支付失败', 'long', 'center');
                    }
                }
            }, function (err) {
                switch (err) {
                case 'fail':
                    var msg = '支付失败';
                    break;
                case 'cancel':
                    var msg = '取消支付';
                    break;
                default:
                    var msg = '取消支付';
                    break;
                }
                $cordovaToast.show(msg, 'long', 'center');
            });
        } catch (e) {
            $cordovaToast.show('发生错误', 'long', 'center');
            // console.log(e);
        }
    }
})

// 确认订单
.controller('checkoutCtrl', function ($scope, $cordovaToast, $ionicModal, $state, locals, Checkout, SystemConfig) {
    $scope.show_bonus = false;
    $scope.payment = 0;
    $scope.postscript = '';
    $scope.getCheckout = function () {
        Checkout.get({ token: locals.get('token') }).$promise.then(function (ret) {
            if (ret.status == 1) {
                // console.log(ret.data);
                $scope.checkout_data = ret.data;
                $scope.amount = parseFloat(ret.data.total.amount).toFixed(2);

                if (ret.data.consignees.length > 0) {
                    $scope.consignee_selected = ret.data.consignees[0];
                    $scope.consignee = ret.data.consignees[0].address_id;
                }
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
                $state.go('app.home');
            }
            $scope.$broadcast('scroll.refreshComplete');
        })
    }
    $scope.getCheckout();

    $ionicModal.fromTemplateUrl('templates/modal/select_address.html', {
        scope: $scope,
        animation: 'slide-in-right'
    }).then(function (modal) {
        $scope.modal = modal;
    });

    // 选择收货地址
    $scope.address = function () {
        $scope.modal.show();
    }
    $scope.selected_address = function (address_id) {
        $scope.consignee = address_id;
        for (var i = 0; i < $scope.checkout_data.consignees.length; i++) {
            if (parseInt($scope.checkout_data.consignees[i].address_id) == parseInt(address_id)) {
                $scope.consignee_selected = $scope.checkout_data.consignees[i];
            }
        }
        // console.log($scope.consignee_selected);
    }

    // 关闭窗口
    $scope.close = function () {
        $scope.modal.hide();
    }

    // 管理收货地址
    $scope.consignee_mamage = function () {
        $scope.close();
        $state.go('app.checkout-address');
    }

    // 隐藏显示可用优惠券
    $scope.toggle_bonus = function () {
        $scope.show_bonus = !$scope.show_bonus;
    }

    // 优惠券选中
    $scope.selected_bonus = function () {
        for (var i = 0; i < $scope.checkout_data.bonus.length; i++) {
            if (parseInt($scope.checkout_data.bonus[i].bonus_id) == parseInt(this.bonus)) {
                $scope.checkout_data.total.bonus = parseFloat($scope.checkout_data.bonus[i].type_money).toFixed(2);
                $scope.amount = (parseFloat($scope.checkout_data.total.amount) - parseFloat($scope.checkout_data.bonus[i].type_money)).toFixed(2);
            }
        }
    }

    // 获取发货时间配置
    SystemConfig.get({ code: 'delivery_time' }).$promise.then(function (ret) {
        // console.log(ret);
        if (ret.status == 1) {
            $scope.delivery_time = ret.data;
        }
    });


    // 提交订单
    $scope.doCheckout = function () {
        if (this.consignee == 0 || this.consignee == undefined) {
            $cordovaToast.show('请选择收货地址', 'long', 'center');
            return false;
        }
        if (this.payment == 0) {
            $cordovaToast.show('请选择支付方式', 'long', 'center');
            return false;
        }

        Checkout.checkout({ token: locals.get('token') }, {
            consignee: parseInt(this.consignee),
            payment: this.payment,
            bonus: this.bonus,
            postscript: this.postscript,
        }).$promise.then(function (ret) {
            if (ret.status == 1) {
                $cordovaToast.show(ret.info, 'long', 'center');
                $state.go('app.pay', { order_id: ret.order_id });
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
            }
        })
    }

    // 下拉刷新
    $scope.doRefresh = function () {
        $scope.getCheckout();
    }
})

// 订单支付
.controller('payCtrl', function ($scope, $rootScope, $cordovaToast, $ionicHistory, $ionicNavBarDelegate, $state, $stateParams, $interval, locals, Pay, Orders) {
    // 隐藏返回按钮
    $ionicNavBarDelegate.showBackButton(false);
    $ionicHistory.removeBackView();
    $ionicHistory.clearHistory();
    $scope.btn_text = '立即支付';
    $scope.status_name = '待支付';
    $scope.to = {
        d: 0,
        h: 0,
        m: 0,
        s: 0
    };
    $scope.getOrder = function () {
        Pay.get({ token: locals.get('token'), order_id: $stateParams.order_id }).$promise.then(function (ret) {
            if (ret.status == 1) {
                ret.data.order.add_time = ret.data.order.add_time + '000';
                $scope.order = ret.data;
                // console.log(ret.data);

                if (ret.data.auto_cancle_time != undefined) {
                    $scope.inter = $interval(function () {
                        var time = (new Date()).valueOf();
                        if (parseInt(ret.data.auto_cancle_time) < time) {
                            $scope.is_passed_time = true;
                            $scope.btn_text = '订单已超时取消';
                            // console.log(parseInt(ret.data.auto_cancle_time));
                            $interval.cancel($scope.inter);
                            $scope.cancel($stateParams.order_id);
                            $scope.status_name = '已关闭';
                            $scope.to = {
                                d: 0,
                                h: 0,
                                m: 0,
                                s: 0
                            };
                            return;
                        }
                        // 倒计时
                        var date = new Date();
                        var nowDate = new Date();
                        date.setTime(ret.data.auto_cancle_time);
                        var t = date.getTime() - nowDate.getTime();
                        $scope.to.d = pad(Math.floor(t / 1000 / 60 / 60 / 24), 2);
                        $scope.to.h = pad(Math.floor(t / 1000 / 60 / 60 % 24), 2);
                        $scope.to.m = pad(Math.floor(t / 1000 / 60 % 60), 2);
                        $scope.to.s = pad(Math.floor(t / 1000 % 60), 2);

                        function pad(num, n) {
                            var len = num.toString().length;
                            while (len < n) {
                                num = "0" + num;
                                len++;
                            }
                            return num;
                        }
                    }, 1000);
                }

                $scope.pay();

                $scope.$broadcast('scroll.refreshComplete');
            } else {
                $cordovaToast.show(ret.info, 'long', 'center');
                $state.go('app.home');
            }
        })
    }
    $scope.getOrder();

    // 下拉刷新
    $scope.doRefresh = function () {
        $scope.getOrder();
    }

    // 调起支付订单
    $scope.pay = function () {
        if ($scope.is_passed_time) {
            return false;
        }
        var charge = $scope.order.charge;
        try {
            pingpp.createPayment(charge, function (result) {
                // console.log(result);
                if (result == 'success') {
                    $cordovaToast.show('支付成功', 'long', 'center');
                    $rootScope.cart_total_price = '￥0.00';
                    $state.go('app.user')
                } else {
                    if (result == 'cancle') {
                        $cordovaToast.show('取消支付', 'long', 'center');
                    } else if (result == 'fail') {
                        $cordovaToast.show('支付失败', 'long', 'center');
                    }
                }
            }, function (err) {
                switch (err) {
                case 'fail':
                    var msg = '支付失败';
                    break;
                case 'cancel':
                    var msg = '取消支付';
                    break;
                default:
                    var msg = '取消支付';
                    break;
                }
                $cordovaToast.show(msg, 'long', 'center');
            });
        } catch (e) {
            $cordovaToast.show('发生错误', 'long', 'center');
            // console.log(e);
        }
    }


    // 取消订单
    $scope.cancel = function (order_id) {
        Orders.delete({ token: locals.get('token'), order_id: order_id }).$promise.then(function (ret) {
            $cordovaToast.show('订单超时已取消', 'long', 'center');
            if (ret.status == 1) {
                $scope.getOrder();
            }
        })
    }


    // 切换页面时显示返回
    $rootScope.$on('$stateChangeStart', function (event, toState, toParams,
        fromState, fromParams, options) {
        $ionicNavBarDelegate.showBackButton(true);
    })
})

// 搜索
.controller('searchCtrl', function ($scope) {

})
