angular.module('starter.directive', [])

.directive('appBrowser', function ($cordovaInAppBrowser) {
    return {
        link: function ($scope, ele, attr) {
            ele.on("click", function (e) {
                var options = {
                    location: 'no',
                    clearcache: 'yes',
                    toolbar: 'no'
                };
                $cordovaInAppBrowser.open(attr.href, '_system', options)
                    .then(function (event) {
                        // success
                    })
                    .catch(function (event) {
                        // error
                    });
                e.stopPropagation();
                e.preventDefault();
            });
        }
    }
})

.directive('adLink', function ($cordovaInAppBrowser, $location) {
    return {
        restrict: 'EAC',
        scope: {
            link: '@',
            out: '@'
        },
        link: function ($scope, ele, attr) {
            ele.on("click", function (e) {
                if ($scope.out == true || $scope.out == 'true') {
                    var options = {
                        location: 'no',
                        clearcache: 'yes',
                        toolbar: 'no'
                    };
                    $cordovaInAppBrowser.open($scope.link, '_system', options)
                        .then(function (event) {
                            // success
                        })
                        .catch(function (event) {
                            // error
                        });
                } else {
                    var link = $scope.link.slice(1);
                    $location.path(link);
                }
                e.stopPropagation();
                e.preventDefault();
            });
        }
    };
})

.directive('repeatDone', function () {
    return {
        link: function (scope, element, attrs) {
            if (scope.$last) { // 这个判断意味着最后一个 OK
                scope.$eval(attrs.repeatDone) // 执行绑定的表达式
            }
        }
    }
})
